Subject: Re: WARNING: Serious Pentium Bug
From: [email-masked] (Weiqi Gao)

8 Nov 1997 18:38:25 -0800
Message-ID: <[email-masked]>
References: <[email-masked]>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
To: [email-masked]

Corey Minyard wrote:
> 
> Anonymous <[email-masked]> writes:
> 
> >
> > There is a SERIOUS bug in all pentium CPUs. The following
> > code will crash any machine running on a pentium CPU, MMX or no
> > MMX, any speed, regardless of OS (crash as in instant seize, hard
> > reboot the only cure):
> >
> > char x [5] = { 0xf0, 0x0f, 0xc7, 0xc8 };
> >
> > main ()
> > {
> >        void (*f)() = x;
> >        f();
> > }
> >
> > This require no special permissions to run, it works fine with
> > average-joe-userspace permissions. I have verified this, it works.
> > Demand a new CPU from Intel.
> >
> 
> I tested it on an Intel Pentium 166 MMX and on a Cyrix 686L 166.  It
> did lock up the Pentium but the 686 correctly reported an illegal
> instruction.  I tried it under Linux and NT, So it is not just a
> Microsoft OS problem.  This does look pretty serious.
> 
> Demand a new CPU?  I'm not sure what Intel will do about this one.
> 
> Who is this and how long did you look for this?  Perhaps Cyrix
> or AMD :-?  I think that finding this would be a pretty momentous
> thing, I'm not sure I would go anonymous.

A few observations:

1.  After receiving the Anonymous post from GNU-Win32 list, I tested the
code on my machine and it did lock up my machine (Pentium 200MHz) under
Windows NT 4.0 SP3, Windows 95, Linux 2.1.12, and Windows 98 Beta. 
GNU-Win32 Beta 18, DJGPP 2.01 and MSVC 5.0 all produced the offending
code.  However on my other machine (Pentium 83MHz overdrive for 483
motherboards, Windows 98 Beta and DJGPP 2.01) a SIGILL was trapped.

2.  This topic dominated the comp.sys.intel news group, which is an
appropriate place for the discussion.

3.  Intel has posted in that group saying essentially -We noticed the
discussion here, and is investigating.-

4.  Several people (including Robert Colins, who wrote the Pentium II
math bug article for Dr. Dobb's Journal) hase came forward and stated
that the bug was known for sometime now.  The reason they did not
publicize it on the internet is their concern for the security of
Pentium based multi-user servers.

5.  Several test programs (including a four byte .COM program) was
posted which works under Windows.

6.  The bug was not present on AMD and Cyrix chips.

--
Weiqi Gao
[email-masked]
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".